from src.models.abstract_reference import abstract_reference
from src.settings.settings import settings
from src.errors.argument_exception import argument_exception

class company_model (abstract_reference):
    # ИНН
    __tax_id = 0
    # БИК
    __bank_id = 0
    # Счет
    __bank_account_id = 0
    # Форма собственности
    __property_type = ""


    def __init__(self, data: settings):
        """
        Args:
            data (settings): Объект настроек с данными организации
        """
        if not isinstance(data, settings):
            raise argument_exception(
                "Аргумент data должен быть типа settings")
        self.__tax_id = settings.tax_id
        self.__bank_id = settings.bank_id
        self.__bank_account_id = settings.bank_account_id
        self.__property_type = settings.property_type

    @property
    def tax_id(self):
        """ИНН"""

        return self.__tax_id
    
    @property
    def bank_id(self):
        """БИК"""

        return self.__bank_id
    
    @property
    def bank_account_id(self):
        """Банковский счет"""

        return self.__bank_account_id
    
    @property
    def property_type(self):
        """Вид собственности"""

        return self.__property_type